       LIST

;==========================================================================
; Build date : Jun 02 2017
;  HCIDE HC18P111L processor include
; 
;  (c) Copyright 2012-2017 Holychip Technology, All rights reserved
;==========================================================================

        NOLIST

;==========================================================================
;  This header file defines configurations, registers, and other useful
;  bits of information for the HC18P111L microcontroller.  These names
;  are taken to match the data sheets as closely as possible.
;
;  Note that the processor must be selected before this file is included.
;  The processor may be selected the following ways:
;
;       1. Command line switch:
;       2. LIST directive in the source file
;               LIST   P=HC18P111L
;       3. Processor Type entry in the HCIDE full-screen interface
;       4. Setting the processor in the HCIDE Project Dialog
;==========================================================================

;==========================================================================
;
;       Verify Processor
;
;==========================================================================
        IFNDEF __18P111L
           MESSG "Processor-header file mismatch.  Verify selected processor."
        ENDIF



;==========================================================================
;
;       Register Definitions
;
;==========================================================================

W                EQU  H'0000'
F                EQU  H'0001'

;----- Register Files -----------------------------------------------------

;-----Bank0------------------
INDF                    EQU     H'0000'
T0                      EQU     H'0001'
PCL                     EQU     H'0002'
STATUS                  EQU     H'0003'
FSR                     EQU     H'0004'
PORTA                   EQU     H'0005'
PORTB                   EQU     H'0006'
;PORTC	                EQU     H'0007'
;PORTD	                EQU     H'0008'	
PCLATH                  EQU     H'000A'
INTCON                  EQU     H'000B'
PIR1	                EQU     H'000C'
PIR2	                EQU     H'000D'
T1L	                EQU     H'000E'
T1H	               	EQU     H'000F'
T1CON	                EQU     H'0010'
T2  		        EQU     H'0011'
T2CON			EQU     H'0012'
WPUB	  	       	EQU     H'0013'
IOCB			EQU     H'0014'
CCPR1L	                EQU     H'0015'
CCPR1H	                EQU     H'0016'	
CCP1CON	                EQU     H'0017'
PR1L			EQU	H'0018'
PR1CON			EQU		H'0019'
CCPR2L	                EQU     H'001B'		
CCPR2H	                EQU     H'001C'	
CCP2CON	                EQU     H'001D'	
ADRESH	                EQU     H'001E'
ADCON0	                EQU     H'001F'
        		
;-----Bank1------------------   	
OPTION                  EQU     H'0081'
TRISA	                EQU     H'0085'
TRISB                   EQU     H'0086'
ADCKCS                  EQU     H'0087'
;TRISD                  EQU     H'0088'
PIE1                    EQU     H'008C'
PIE2                    EQU     H'008D'
PCON                    EQU     H'008E'
T1GCON                  EQU     H'008F'
OSCCON                  EQU     H'0090'	
PR2		       	EQU     H'0092'
WPUA                    EQU     H'0093'
PMDATL			EQU	H'0094'
PMDATH			EQU	H'0095'
PMADRL			EQU	H'0096'
PMADRH			EQU	H'0097'
PMCON			EQU	H'0098'	
ANSEL	                EQU     H'009D'
ADRESL                  EQU     H'009E'
ADCON1                  EQU     H'009F'



;----- STATUS Bits --------------------------------------------------------

IRP                    	EQU     H'0007'
RP1                     EQU     H'0006'
RP0                     EQU     H'0005' 
TO                      EQU     H'0004'
PD                      EQU     H'0003'
Z                       EQU     H'0002'
DC                      EQU     H'0001'
C                       EQU     H'0000'

;----- INTCON Bits --------------------------------------------------------

GIE                     EQU     H'0007'
PEIE			EQU     H'0006'
T0IE                   	EQU     H'0005'
INTE                    EQU     H'0004'
RBIE                    EQU     H'0003'
T0IF                   	EQU     H'0002'
INTF                    EQU     H'0001'
RBIF                    EQU     H'0000'

;----- PORTA Bits --------------------------------------------------------

PORTA7                  EQU     H'0007'
PORTA6			EQU     H'0006'
PORTA5                 	EQU     H'0005'
PORTA4                  EQU     H'0004'
PORTA3                  EQU     H'0003'
PORTA2                  EQU     H'0002'
PORTA1                  EQU     H'0001'
PORTA0                  EQU     H'0000'

;----- PORTB Bits --------------------------------------------------------

PORTB7                  EQU     H'0007'
PORTB6			EQU     H'0006'
PORTB5                 	EQU     H'0005'
PORTB4                  EQU     H'0004'
PORTB3                  EQU     H'0003'
PORTB2                  EQU     H'0002'
PORTB1                  EQU     H'0001'
PORTB0                  EQU     H'0000'

;----- PIR1 Bits --------------------------------------------------------

T1GIF                   EQU     H'0007'
ADIF                    EQU     H'0006'	
CCP1IF                  EQU     H'0002'
T2IF                    EQU     H'0001'
T1IF                    EQU     H'0000'

;----- PIR2 Bits --------------------------------------------------------
CCP2IF                  EQU     H'0000'

;----- T1CON Bits ----------------------------------------------------------
T1CS1                   EQU     H'0007'
T1CS0                   EQU     H'0006'
T1CKPS1                 EQU     H'0005'
T1CKPS0                 EQU     H'0004'
T1OSCEN                 EQU     H'0003'
T1SYNC                  EQU     H'0002'
T1ON                    EQU     H'0000'

;----- T2CON Bits ----------------------------------------------------------
T2CKPS3                 EQU     H'0006'
T2CKPS2                 EQU     H'0005'
T2CKPS1                 EQU     H'0004'
T2CKPS0                 EQU     H'0003'
T2ON                    EQU     H'0002'


;----- TRISA Bits --------------------------------------------------------

TRISA7                  EQU     H'0007'
TRISA6					EQU     H'0006'
TRISA5                 	EQU     H'0005'
TRISA4                  EQU     H'0004'
TRISA3                  EQU     H'0003'
TRISA2                  EQU     H'0002'
TRISA1                  EQU     H'0001'
TRISA0                  EQU     H'0000'

;----- TRISB Bits --------------------------------------------------------

TRISB7                  EQU     H'0007'
TRISB6					EQU     H'0006'
TRISB5                 	EQU     H'0005'
TRISB4                  EQU     H'0004'
TRISB3                  EQU     H'0003'
TRISB2                  EQU     H'0002'
TRISB1                  EQU     H'0001'
TRISB0                  EQU     H'0000'

;----- WPUB Bits ----------------------------------------------------------

WPUB7	                EQU     H'0007'
WPUB6	                EQU     H'0006'
;WPUB5	                EQU     H'0005'
;WPUB4	                EQU     H'0004'
WPUB3                	EQU     H'0003'
WPUB2	                EQU     H'0002'
WPUB1	                EQU     H'0001'
WPUB0	                EQU     H'0000'

;----- IOCB Bits ----------------------------------------------------------

IOCB7	                EQU     H'0007'
IOCB6	                EQU     H'0006'
IOCB5	                EQU     H'0005'
;IOCB4	                EQU     H'0004'
IOCB3                	EQU     H'0003'
IOCB2	                EQU     H'0002'
IOCB1	                EQU     H'0001'
IOCB0	                EQU     H'0000'

;----- CCP1CON Bits ----------------------------------------------------------

DC1B1                   EQU     H'0005'
DC1B0                   EQU     H'0004'
CCP1M3                  EQU     H'0003'
CCP1M2                  EQU     H'0002'
CCP1M1                  EQU     H'0001'
CCP1M0                  EQU     H'0000'

;----- CCP2CON Bits ----------------------------------------------------------

DC2B1                   EQU     H'0005'
DC2B0                   EQU     H'0004'
CCP2M3                  EQU     H'0003'
CCP2M2                  EQU     H'0002'
CCP2M1                  EQU     H'0001'
CCP2M0                  EQU     H'0000'

;----- ADCON0 Bits ----------------------------------------------------------
VHS1					EQU		H'0006'
VHS0					EQU		H'0005'
CHS2                    EQU     H'0004'
CHS1                    EQU     H'0003'
CHS0                    EQU     H'0002'
ADON                   	EQU     H'0001'
ADEN                    EQU     H'0000'
;----- PR1CON Bits ----------------------------------------------------------
PWM1T1			EQU	H'0007'
PWM1T0			EQU	H'0006'
PWM2T1			EQU	H'0005'
PWM2T0			EQU	H'0004'
T1CKPS3			EQU	H'0003'
T1CKPS2			EQU	H'0002'
PWMPR1			EQU	H'0001'
PR1EN			EQU	H'0000'

;----- OPTION Bits --------------------------------------------------------
RBPUB                   EQU     H'0007'
INTEDG                  EQU     H'0006'
T0CS                    EQU     H'0005'
T0SE                    EQU     H'0004'
PSA                     EQU     H'0003'
PS2                     EQU     H'0002'
PS1                     EQU     H'0001'
PS0                     EQU     H'0000'

;----- ADCKCS Bits --------------------------------------------------------
ADCKCS2			EQU     H'0002'
ADCKCS1			EQU     H'0001'
ADCKCS0			EQU     H'0000'

;----- PIE1 Bits ----------------------------------------------------------
T1GIE                   EQU     H'0007'
ADIE                    EQU     H'0006'
CCP1IE                  EQU     H'0002'
T2IE                    EQU     H'0001'
T1IE                    EQU     H'0000'

;----- PIE2 Bits ----------------------------------------------------------
CCP2IE                  EQU     H'0000'

;----- PCON Bits ----------------------------------------------------------

LVD2EN                  EQU     H'0007'
LVD1EN                  EQU     H'0006'		
WDTENS                  EQU     H'0004'			
LVD2F                   EQU     H'0003'
LVD1F                   EQU     H'0002'
POR                     EQU     H'0001'
BOR                     EQU     H'0000'

;----- T1GCON Bits ----------------------------------------------------------

T1GEN                   EQU     H'0007'
T1GPOL                  EQU     H'0006'
T1GTM                   EQU     H'0005'
T1GSPM                  EQU     H'0004'
T1GON                   EQU     H'0003'
T1GVAL                  EQU     H'0002'
T1GSS1                  EQU     H'0001'
T1GSS0                  EQU     H'0000'

;----- OSCCON Bits ----------------------------------------------------------

T0OSCEN                 EQU     H'0007'
HXEN                    EQU     H'0001'
SCS                     EQU     H'0000'

;----- WPUA Bits ----------------------------------------------------------

WPUA7	                EQU     H'0007'
WPUA6	                EQU     H'0006'
;WPUA5	                EQU     H'0005'
WPUA4	                EQU     H'0004'
WPUA3                	EQU     H'0003'
WPUA2	                EQU     H'0002'
WPUA1	                EQU     H'0001'
WPUA0	                EQU     H'0000'

;----- ANSEL Bits ----------------------------------------------------------

ANSEL7	                EQU     H'0007'
ANSEL6	                EQU     H'0006'
;ANSEL5	                EQU     H'0005'
ANSEL4	                EQU     H'0004'
ANSEL3                	EQU     H'0003'
ANSEL2	                EQU     H'0002'
ANSEL1	                EQU     H'0001'
ANSEL0	                EQU     H'0000'

;----- ADCON1 Bits ----------------------------------------------------------

ADFM                    EQU     H'0007'
ADCS2                   EQU     H'0006'
ADCS1                   EQU     H'0005'
ADCS0                   EQU     H'0004'
ADREF                   EQU     H'0000'

;----- PMCON Bits ----------------------------------------------------------
RDON			EQU	H'0000'



;==========================================================================
;
;       RAM Definitions
;
;==========================================================================
       __MAXRAM  H'00FF'
    
       __BADRAM  H'0007'-H'0009'
       __BADRAM  H'001a'
       __BADRAM  H'0088'-H'0089'
       __BADRAM  H'0091'
       __BADRAM  H'0099'-H'009c'    
       
       

     
;==========================================================================
;
;       Configuration Bits
;
;   NAME            Address
;   CONFIG            2000h
;
;==========================================================================

; The following is an assignment of address values for all of the
; configuration registers for the purpose of table reads
_CONFIG          EQU  H'2000'


;----- CONFIG Options --------------------------------------------------
_FOSC_LP             EQU  H'3CFF'    ; LP oscillator: Low-power crystal on RA4/OSC2/CLKOUT and RA5/OSC1/CLKIN
_LP_OSC              EQU  H'3CFF'    ; LP oscillator: Low-power crystal on RA4/OSC2/CLKOUT and RA5/OSC1/CLKIN
_FOSC_XT             EQU  H'3DFF'    ; XT oscillator: Crystal/resonator on RA4/OSC2/CLKOUT and RA5/OSC1/CLKIN
_XT_OSC              EQU  H'3DFF'    ; XT oscillator: Crystal/resonator on RA4/OSC2/CLKOUT and RA5/OSC1/CLKIN
_FOSC_HS             EQU  H'3FFD'    ; HS oscillator: High-speed crystal/resonator on RA4/OSC2/CLKOUT and RA5/OSC1/CLKIN
_HS_OSC              EQU  H'3FFD'    ; HS oscillator: High-speed crystal/resonator on RA4/OSC2/CLKOUT and RA5/OSC1/CLKIN
;_FOSC_EC             EQU  H'3FFD'    ; EC: I/O function on RA4/OSC2/CLKOUT pin, CLKIN on RA5/OSC1/CLKIN
;_EC_OSC              EQU  H'3FFB'    ; EC: I/O function on RA4/OSC2/CLKOUT pin, CLKIN on RA5/OSC1/CLKIN
_FOSC_INTRCIO        EQU  H'3FFC'    ; INTOSCIO oscillator: I/O function on RA4/OSC2/CLKOUT pin, I/O function on RA5/OSC1/CLKIN
_INTRC_OSC_NOCLKOUT  EQU  H'3FFC'    ; INTOSCIO oscillator: I/O function on RA4/OSC2/CLKOUT pin, I/O function on RA5/OSC1/CLKIN
_INTOSCIO            EQU  H'3FFC'    ; INTOSCIO oscillator: I/O function on RA4/OSC2/CLKOUT pin, I/O function on RA5/OSC1/CLKIN
;_FOSC_INTRCCLK       EQU  H'3FFD'    ; INTOSC oscillator: CLKOUT function on RA4/OSC2/CLKOUT pin, I/O function on RA5/OSC1/CLKIN
;_INTRC_OSC_CLKOUT    EQU  H'3FFD'    ; INTOSC oscillator: CLKOUT function on RA4/OSC2/CLKOUT pin, I/O function on RA5/OSC1/CLKIN
;_INTOSC              EQU  H'3FFD'    ; INTOSC oscillator: CLKOUT function on RA4/OSC2/CLKOUT pin, I/O function on RA5/OSC1/CLKIN
;_FOSC_EXTRCIO        EQU  H'3FFE'    ; RCIO oscillator: I/O function on RA4/OSC2/CLKOUT pin, RC on RA5/OSC1/CLKIN
;_EXTRC_OSC_NOCLKOUT  EQU  H'3FFE'    ; RCIO oscillator: I/O function on RA4/OSC2/CLKOUT pin, RC on RA5/OSC1/CLKIN
;_EXTRCIO             EQU  H'3FFE'    ; RCIO oscillator: I/O function on RA4/OSC2/CLKOUT pin, RC on RA5/OSC1/CLKIN
;_FOSC_EXTRCCLK       EQU  H'3FFF'    ; RC oscillator: CLKOUT function on RA4/OSC2/CLKOUT pin, RC on RA5/OSC1/CLKIN
;_EXTRC_OSC_CLKOUT    EQU  H'3FFF'    ; RC oscillator: CLKOUT function on RA4/OSC2/CLKOUT pin, RC on RA5/OSC1/CLKIN
;_EXTRC               EQU  H'3FFF'    ; RC oscillator: CLKOUT function on RA4/OSC2/CLKOUT pin, RC on RA5/OSC1/CLKIN

_WDTE_OFF            EQU  H'3FFB'    ; WDT disabled and can be enabled by SWDTEN bit of the WDTCON register
_WDT_OFF             EQU  H'3FFB'    ; WDT disabled and can be enabled by SWDTEN bit of the WDTCON register
_WDTE_ON             EQU  H'3FFF'    ; WDT enabled
_WDT_ON              EQU  H'3FFF'    ; WDT enabled

;_PWRTE_ON            EQU  H'3FEF'    ; PWRT enabled
;_PWRTE_OFF           EQU  H'3FFF'    ; PWRT disabled

;_MCLRE_OFF           EQU  H'3FDF'    ; MCLR pin function is digital input, MCLR internally tied to VDD
;_MCLRE_ON            EQU  H'3FFF'    ; MCLR pin function is MCLR

_CP_ON               EQU  H'3FEF'    ; Program memory code protection is enabled
_CP_OFF              EQU  H'3FFF'    ; Program memory code protection is disabled

;_CPD_ON              EQU  H'3F7F'    ; Data memory code protection is enabled
;_CPD_OFF             EQU  H'3FFF'    ; Data memory code protection is disabled

;_BOREN_OFF           EQU  H'3CFF'    ; BOR disabled
;_BOD_OFF             EQU  H'3CFF'    ; BOR disabled
;_BOR_OFF             EQU  H'3CFF'    ; BOR disabled
;_BOREN_SBODEN        EQU  H'3DFF'    ; BOR controlled by SBOREN bit of the PCON register
;_BOD_SBODEN          EQU  H'3DFF'    ; BOR controlled by SBOREN bit of the PCON register
;_BOR_SBODEN          EQU  H'3DFF'    ; BOR controlled by SBOREN bit of the PCON register
;_BOREN_NSLEEP        EQU  H'3EFF'    ; BOR enabled during operation and disabled in Sleep
;_BOD_NSLEEP          EQU  H'3EFF'    ; BOR enabled during operation and disabled in Sleep
;_BOR_NSLEEP          EQU  H'3EFF'    ; BOR enabled during operation and disabled in Sleep
;_BOREN_ON            EQU  H'3FFF'    ; BOR enabled
;_BOD_ON              EQU  H'3FFF'    ; BOR enabled
;_BOR_ON              EQU  H'3FFF'    ; BOR enabled

;_IESO_OFF            EQU  H'3BFF'    ; Internal External Switchover mode is disabled
;_IESO_ON             EQU  H'3FFF'    ; Internal External Switchover mode is enabled

;_FCMEN_OFF           EQU  H'37FF'    ; Fail-Safe Clock Monitor is disabled
;_FCMEN_ON            EQU  H'3FFF'    ; Fail-Safe Clock Monitor is enabled

;----- DEVID Equates --------------------------------------------------
;_DEVID1          EQU  H'2006'

;----- IDLOC Equates --------------------------------------------------
;_IDLOC0          EQU  H'2000'
;_IDLOC1          EQU  H'2001'
;_IDLOC2          EQU  H'2002'
;_IDLOC3          EQU  H'2003'

       
        LIST